<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Account_photos extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        $this->load->library('Multiquery');
    }
    public function index($id){
    	$this->db->select('LongName');
    	$data_name = $this->db->get_where('ptsl_accountinfo', array('AccountID'=>$id))->result_array();
    	$account_name = $data_name[0]['LongName'];
    	$this->db->select('act.ActivityID ,photos.thumbnail,photos.PhotoID');
    	$this->db->from('ptsl_account_activity act');
    	$this->db->join('ptsl_activity_photos photos','act.ActivityID=photos.ActivityID','');
    	$this->db->where('act.AccountID',$id);
    	$this->db->where('photos.thumbnail!=""');
    	$data = $this->db->get()->result_array();
        $new_array = array(); 
        foreach($data as $key=>$adata){
            $new_array[$key]['id'] =$key;
            $new_array[$key]['src'] = $adata['thumbnail'];
            $new_array[$key]['ActivityID'] = $adata['ActivityID'];
            $new_array[$key]['PhotoID'] =$adata['PhotoID'];
        }
    	if($data){
    		$response= array(
    			'status' => TRUE,
    			'account_photos' => $new_array,
    			'account_name' => $account_name  
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status'=> FALSE,
    			'message'=> 'No data found'
    		);
    		echo json_encode($response);
    	}
    }
    public function index_v2($user_id,$account_id){

        $spn = "Call ptsl_sp_get_photos_account('".$user_id."','".$account_id."')";
        $data = $this->multiquery->GetResults($spn);
        $new_array = array();
        $photos_id_array =array(); 
        foreach($data[1] as $key=>$adata){
            $new_array[$key]['id'] =$key;
            $photos_id_array[$key]['PhotoID'] = $adata['PhotoID'];
            $new_array[$key]['src'] = $adata['thumbnail'];
            $new_array[$key]['ActivityID'] = $adata['ActivityID'];
            $new_array[$key]['is_event'] =$adata['is_event'];
            $new_array[$key]['title'] = $adata['photo_title'];
            $new_array[$key]['number_of_comments'] = $adata['number_of_comments'];
            if($adata['is_event'] == 1){
                $new_array[$key]['url'] = "#/eventdetails5/".$adata['ActivityID'];
            }
            else{
                $new_array[$key]['url'] = "#/activitydetails5/".$adata['ActivityID'];
            }
        }
        if(@$new_array){
            $response= array(
                'status' => TRUE,
                'account_photos' => $new_array,
                'photos_id' =>$photos_id_array,
                'acc_name' =>$data[2]  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function allphotos(){
        $rep_id = @$this->input->get('rep');
        $date = @$this->input->get('date');
        $date2 = @$this->input->get('date2');
        $region = @$this->input->get('region');
        $this->db->select('photos.PhotoID');
        $this->db->from('ptsl_account_activity act');
        $this->db->join('ptsl_activity_photos photos','act.ActivityID = photos.ActivityID','');
        $this->db->where('photos.thumbnail!=""');
        if(@$rep_id){
            $this->db->where('act.Client_Rep_ID',$rep_id);
        }
        if(@$date){
            $this->db->where('act.ActivityDate',$date);
        }
        $this->db->group_by('act.ActivityDate');
        $this->db->order_by('act.ActivityDate','desc');
        $distinct_dates = $this->db->get()->result_array();
       
        foreach ($distinct_dates as $key => $distinct_date) {
           $data_array[$key]['date'] =  str_replace(array('`',']'), '',$distinct_date['date']);
           $this->db->select('act.ActivityID,IFNULL(act.isEvent,0) as is_event,photos.thumbnail,photos.taken_date,act.ActivityDate');
           $this->db->from('ptsl_account_activity act');
           $this->db->join('ptsl_activity_photos photos','act.ActivityID=photos.ActivityID','');
           $this->db->where('act.ActivityDate',$distinct_date['ActivityDate']);
           $this->db->where('photos.thumbnail!=""');

           $thumbnails = $this->db->get()->result_array();
           foreach($thumbnails as $key2 => $thumbnail){
                $thumbnails[$key2]['id'] =$key2;
                if($thumbnail['is_event']== 1){
                    $thumbnails[$key2]['url'] = "#/eventdetails/".$thumbnail['ActivityID'];
                }
                elseif ($thumbnail['is_event']== 0) {
                    $thumbnails[$key2]['url'] = "#/activitydetails/".$thumbnail['ActivityID'];
                }
           }
           $data_array[$key]['thumbnails'] = $thumbnails;
        }
        //print_r($data_array); exit;
        //$new_array = array(); 
       /* foreach($data as $key=>$adata){
            $new_array[$key]['id'] =$key;
            $new_array[$key]['src'] = $adata['thumbnail'];
            $new_array[$key]['ActivityID'] = $adata['ActivityID'];
            $new_array[$key]['is_event'] =$adata['is_event'];
            if($adata['is_event'] == 1){
                $new_array[$key]['url'] = "#/eventdetails/".$adata['ActivityID'];
            }
            else{
                $new_array[$key]['url'] = "#/activitydetails/".$adata['ActivityID'];
            }
        }*/
        if(@$data_array){
            $response= array(
                'status' => TRUE,
                'photos_id' => $data_array  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function allphotos_v2(){
        $rep_id = @$this->input->get('rep');
        $date = @$this->input->get('date');
        $date2 = @$this->input->get('date2');
        $region = @$this->input->get('region');
        $user_id = @$this->input->get('user_id');
        $my_region = @$this->input->get('my_region');
        $brand = @$this->input->get('brand');
        $tag = @$this->input->get('tag');
        $year= @$this->input->get('year');
        $quarter = @$this->input->get('quarter');
        $spn = "call ptsl_sp_get_photos('".$user_id."','".$rep_id."','".$date."','".$date2."','".$region."','".$my_region."','".$tag."','".$brand."','".$year."','".$quarter."')";
        $data = $this->multiquery->GetResults($spn);
        //print_r($data);
        $photos_id_array =array();
        //$new_array = array(); 
        foreach($data[1] as $key=>$adata){
            $new_array[$key]['id'] =$key;
            //array_push($photos_id_array, $adata['PhotoID']);
            $photos_id_array[$key]['PhotoID'] = $adata['PhotoID'];
            $new_array[$key]['src'] = $adata['thumbnail'];
            $new_array[$key]['ActivityID'] = $adata['ActivityID'];
            $new_array[$key]['is_event'] =$adata['is_event'];
            $new_array[$key]['title'] = $adata['photo_title'];
            $new_array[$key]['number_of_comments'] = $adata['number_of_comments'];
            if($adata['is_event'] == 1){
                $new_array[$key]['url'] = "#/eventdetails4/".$adata['ActivityID'];
            }
            else{
                $new_array[$key]['url'] = "#/activitydetails4/".$adata['ActivityID'];
            }
        }
        if(@$new_array){
            $response= array(
                'status' => TRUE,
                'all_photos' => $new_array,
                //'photos_id' =>$data[2],
                'photos_id' =>$photos_id_array   
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function getPhotos($photoid){
        $this->db->select('p.Photo');
        //$this->db->where('PhotoID',$photoid);
        $this->db->from('ptsl_activity_photos p');
        $this->db->join('ptsl_account_activity a','p.ActivityID=a.ActivityID','');
       // $this->db->where('a.AccountID',$id);
        $this->db->where('PhotoID',$photoid);
        $this->db->where('p.thumbnail!=""');
        $data = $this->db->get()->result_array();
        $res = $this->db->query("select ptsl_fn_get_number_of_comments('".$photoid."') as comments")->result_array();
        if($res[0]['comments']){
            $number_of_comments = $res[0]['comments']; 
        }else{
             $number_of_comments = '';
        }
        if($data){
          $response= array(
                'status' => TRUE,
                'photos' => $data[0]['Photo'],
                'number_of_comments' => $number_of_comments   
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function getPhotosid($id){
        $this->db->select('p.PhotoID');
        //$this->db->where('PhotoID',$photoid);
        $this->db->from('ptsl_activity_photos p');
        $this->db->join('ptsl_account_activity a','p.ActivityID=a.ActivityID','');
        $this->db->where('a.AccountID',$id);
        $this->db->where('p.thumbnail!=""');
        $data = $this->db->get()->result_array();
        if($data){
          $response= array(
                'status' => TRUE,
                'photos_id' => $data  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function getPhotoName($id){
        $spn = "call ptsl_sp_get_photo_attachement_name('".$id."')";
        $data = $this->multiquery->GetResults($spn);
        //var_dump($data);
        if($data){
          $response= array(
                'status' => TRUE,
                'photo_name' => $data[0]  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
	private function ak_img_thumb($target, $newcopy, $w, $h, $ext) {
	    list($w_orig, $h_orig) = getimagesize($target);
	    $src_x = ($w_orig / 2) - ($w / 2);
	    $src_y = ($h_orig / 2) - ($h / 2);
	    $ext = strtolower($ext);
	    $img = "";
	    if ($ext == "gif"){ 
	    $img = imagecreatefromgif($target);
	    } else if($ext =="png"){ 
	    $img = imagecreatefrompng($target);
	    } else { 
	    $img = imagecreatefromjpeg($target);
	    }
	    $tci = imagecreatetruecolor($w, $h);
	    //imagecopyresampled($tci, $img, 0, 0, $src_x, $src_y, $w, $h, $w_orig, $h_orig);
	    imagecopyresampled($tci, $img, 0, 0, 0, 0, $w, $h, $w_orig, $h_orig);
	    if ($ext == "gif"){ 
	        imagegif($tci, $newcopy);
	    } else if($ext =="png"){ 
	        imagepng($tci, $newcopy);
	    } else { 
	       $t= imagejpeg($tci, $newcopy, 84);
	       //echo base64_encode($t);

	    }
	   //echo base64_encode($target);
	}
    public function makejpg(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        //print_r($post_data); 
        $image =$post_data['image'];
        $loc="../accountapi/email_photos/";

        $imgData1 = $image;
        $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
      //  echo $imgData1;
       // $sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
        $image_file=date('YmdHis').'MyFile.jpg';
        $tes = file_put_contents($loc.$image_file, base64_decode($imgData1));
        //echo $tes;
        if($image_file){
            $response= array(
                'status' => TRUE,
                'photo' =>  "http://periscopedemo.com/accountapi/email_photos/".$image_file 
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function addComment(){
        $post_data = json_decode(file_get_contents('php://input'), true);

        $user_id = $post_data['userid'];
        $photo_id = $post_data['photo_id'];
        $comment = $post_data['comment'];
        $data = array(
            'photo_id' => $photo_id,
            'comment'   => $comment,
            'user_id'   => $user_id,
            'date_created'=> date("Y-m-d H:i:s")
        );
        $res = $this->db->insert('ptsl_photo_comments',$data);
        if($res){
            $spn = "call `ptsl_sp_get_photocomment_notifications`('".$user_id."','".$photo_id."')";
            //echo $spn;
            //$spn = "call `ptsl_sp_get_photocomment_notifications`(3,192)";
            $data_decives = $this->multiquery->GetResults($spn);
            //print_r($data_decives);
            if(@$data_decives[2][0]['photo_user_id']){
                $notification_data = array(
                    'user_id' => $data_decives[2][0]['photo_user_id'],
                    'notification' => $data_decives[3][0]['comment_by'].' commented on your photo',
                    'notification_url' => '',
                    'created_date' => date('Y-m-d H:i:s')
                );
                $this->db->insert('ptsl_user_notifications',$notification_data); 
                $res = $this->send_push($data_decives[1],'',$data_decives[3][0]['comment_by']." commented on your photo");
            }
            $response= array(
                'status' => TRUE,
                'message' => "Success",
                'photo_id' => $photo_id  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function comment_list($photo_id,$user_id){
        $spn = "call ptsl_sp_get_photo_comments('".$user_id."','".$photo_id."')";
        $res = $this->db->query($spn)->result_array();
        if($res){
            //$spn = "call ptsl_sp_get_device_key('".$user_id."')";
            //$devices_array = $this->db->query($spn)->result_array();
            $response= array(
                'status' => TRUE,
                'comments' => $res  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    private function send_push($devices_associative_arr,$order_id,$msg){
        $devices =array();
        foreach ($devices_associative_arr as $key => $device) {
            array_push($devices, $device['device_key']);
        }
    
        $content = array(
          "en" => $msg
          );
        
       $fields = array(
      'app_id' => "e13a6f2b-74f2-4cb8-a109-b4af95c293ce",
     // 'included_segments' => array('All'),
      //'included_segments' => array('789e714d-7e95-4a1f-a65c-75f967f442a3'),
      'include_player_ids' => $devices,
      //'data' => array("state" => "order_details","param"=>$order_id),
      'contents' => $content,
      "ios_badgeType" => "Increase",
      "ios_badgeCount"=> 1
  

    );
        
        $fields = json_encode($fields);
       // print("\nJSON sent:\n");
        //print($fields);
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/notifications");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
                               'Authorization: Basic OTQ0YWM4ODQtNjNjZi00MzJjLThhMjgtZjdiZTcyYWY3YTJl'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);
        
        return $response;
    } 
}